﻿namespace TestLibrary.Common;

/// <summary>
/// 키 바이트 세트
/// </summary>
public class KeyByteSet
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Propery
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 키 바이트 번호 - KeyByteNumber

    /// <summary>
    /// 키 바이트 번호
    /// </summary>
    public int KeyByteNumber { get; }

    #endregion
    #region 키 바이트 A - KeyByteA

    /// <summary>
    /// 키 바이트 A
    /// </summary>
    public byte KeyByteA { get; }

    #endregion
    #region 키 바이트 B - KeyByteB

    /// <summary>
    /// 키 바이트 B
    /// </summary>
    public byte KeyByteB { get; }

    #endregion
    #region 키 바이트 C - KeyByteC

    /// <summary>
    /// 키 바이트 C
    /// </summary>
    public byte KeyByteC { get; }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - KeyByteSet(keyByteNumber, keyByteA, keyByteB, keyByteC)

    /// <summary>
    /// 생성자
    /// </summary>
    /// <param name="keyByteNumber">키 바이트 번호</param>
    /// <param name="keyByteA">키 바이트 A</param>
    /// <param name="keyByteB">키 바이트 B</param>
    /// <param name="keyByteC">키 바이트 C</param>
    /// <exception cref="ArgumentException"></exception>
    public KeyByteSet(int keyByteNumber, byte keyByteA, byte keyByteB, byte keyByteC)
    {
        if(keyByteNumber < 1)
        {
            throw new ArgumentException($"{nameof(keyByteNumber)} should be greater or equal to 1", nameof(keyByteNumber));
        }

        KeyByteNumber = keyByteNumber;
        KeyByteA      = keyByteA;
        KeyByteB      = keyByteB;
        KeyByteC      = keyByteC;
    }

    #endregion
}