﻿using System.Collections;

using TestLibrary.Common;

namespace TestLibrary.Generator;

/// <summary>
/// 키 바이트 세트 비교자
/// </summary>
public class KeyByteSetComparer : IComparer
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 비교하기 - Compare(key1, key2)

    /// <summary>
    /// 비교하기
    /// </summary>
    /// <param name="key1">키 1</param>
    /// <param name="key2">키 2</param>
    /// <returns>비교 결과</returns>
    public int Compare(object key1, object key2)
    {
        KeyByteSet keyByteSet1 = (KeyByteSet)key1;
        KeyByteSet keyByteSet2 = (KeyByteSet)key2;

        if(keyByteSet1 == null)
        {
            throw new ArgumentNullException(nameof(keyByteSet1));
        }

        if(keyByteSet2 == null)
        {
            throw new ArgumentNullException(nameof(keyByteSet2));
        }

        if(keyByteSet1.KeyByteNumber > keyByteSet2.KeyByteNumber)
        {
            return 1;
        }

        if(keyByteSet1.KeyByteNumber < keyByteSet2.KeyByteNumber)
        {
            return -1;
        }

        return 0;
    }

    #endregion
}