﻿using TestLibrary.Common;
using TestLibrary.Generator;

namespace TestProject.Generator
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            while(true)
            {
                KeyByteSet[] keyByteSetArray = new[]
                {
                    new KeyByteSet(keyByteNumber : 1, keyByteA : 58 , keyByteB : 6  , keyByteC : 97 ),
                    new KeyByteSet(keyByteNumber : 2, keyByteA : 96 , keyByteB : 254, keyByteC : 23 ),
                    new KeyByteSet(keyByteNumber : 3, keyByteA : 11 , keyByteB : 185, keyByteC : 69 ),
                    new KeyByteSet(keyByteNumber : 4, keyByteA : 2  , keyByteB : 93 , keyByteC : 41 ),
                    new KeyByteSet(keyByteNumber : 5, keyByteA : 62 , keyByteB : 4  , keyByteC : 234),
                    new KeyByteSet(keyByteNumber : 6, keyByteA : 200, keyByteB : 56 , keyByteC : 49 ),
                    new KeyByteSet(keyByteNumber : 7, keyByteA : 89 , keyByteB : 45 , keyByteC : 142),
                    new KeyByteSet(keyByteNumber : 8, keyByteA : 6  , keyByteB : 88 , keyByteC : 32 )
                };

                int seed = new Random().Next(0, int.MaxValue);

                Console.WriteLine($"시드 (예를 들어 사용자 ID) : {seed}");

                Console.WriteLine();

                LicenseKeyGenerator licenseKeyGenerator = new LicenseKeyGenerator();

                string licenceKey = licenseKeyGenerator.GenerateKey(seed, keyByteSetArray);

                Console.WriteLine($"생성된 라이센스 키 : {licenceKey}");

                Console.WriteLine();

                Console.WriteLine("라이센스 키 검증을 위해서 TestProject.Validator 프로그램에 이 값을 복사한다.");

                Console.WriteLine();

                Console.WriteLine("다른 라이센스 키 생성을 위해 아무 키나 눌러 주시기 바랍니다.");

                Console.WriteLine();

                Console.ReadKey(true);

                Console.WriteLine();
            }
        }

        #endregion
    }
}