﻿using TestLibrary.Common;
using TestLibrary.Validator;

namespace TestProject.Validator;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        while (true)
        {
            KeyByteSet[] keyByteSetArray = new[]
            {
                new KeyByteSet(keyByteNumber: 1, keyByteA: 58, keyByteB: 6, keyByteC: 97),
                new KeyByteSet(keyByteNumber: 5, keyByteA: 62, keyByteB: 4, keyByteC: 234),
                new KeyByteSet(keyByteNumber: 8, keyByteA: 6, keyByteB: 88, keyByteC: 32)
            };

            Console.WriteLine("TestProject.Generator 프로그램에서 생성한 라이센스 키를 입력한다 :");

            string licenseKey = Console.ReadLine();

            Console.WriteLine();

            LicenseKeyValidator licenseKeyValidator = new LicenseKeyValidator();

            LicenseKeyValidationResult licenseKeyValidationResult = licenseKeyValidator.ValidateKey
            (
                key                  : licenseKey?.Trim(),
                keyByteSetArray      : keyByteSetArray,
                totalKeyByteSetCount : 8,
                keyListBlackListed   : null
            );

            Console.WriteLine($"검증 결과 : {licenseKeyValidationResult}");

            Console.WriteLine();

            Console.WriteLine("다른 라이센스 키 검증을 위해 아무 키나 눌러 주시기 바랍니다.");

            Console.ReadKey(true);

            Console.WriteLine();
        }
    }

    #endregion
}